## mail-mt mail-mt |

## Functions

gchar * | (*MailMsgDescFunc) ()
void | (*MailMsgExecFunc) ()
void | (*MailMsgDoneFunc) ()
void | (*MailMsgFreeFunc) ()
void | (*MailMsgDispatchFunc) ()
void | (*MailMsgCreateActivityFunc) ()
void | (*MailMsgSubmitActivityFunc) ()
void | (*MailMsgFreeActivityFunc) ()
void | (*MailMsgCompleteActivityFunc) ()
void | (*MailMsgCancelActivityFunc) ()
void | (*MailMsgAlertErrorFunc) ()
EAlertSink | (*MailMsgGetAlertSinkFunc) ()
EAlertSink * | mail_msg_get_alert_sink ()
void | mail_msg_init ()
void | mail_msg_register_activities ()
gboolean | mail_in_main_thread ()
gpointer | mail_msg_new ()
gpointer | mail_msg_new_with_cancellable ()
gpointer | mail_msg_ref ()
void | mail_msg_unref ()
void | mail_msg_check_error ()
void | mail_msg_cancel ()
gboolean | mail_msg_active ()
void | mail_msg_main_loop_push ()
void | mail_msg_unordered_push ()
void | mail_msg_fast_ordered_push ()
void | mail_msg_slow_ordered_push ()
gpointer | (*MailMainFunc) ()
gpointer | mail_call_main ()

## Types and Values

struct | MailMsg
struct | MailMsgInfo
enum | mail_call_t

## Description

## Functions

### MailMsgDescFunc ()

    gchar *
    (*MailMsgDescFunc) (MailMsg *msg);

### MailMsgExecFunc ()

    void
    (*MailMsgExecFunc) (MailMsg *msg,
                        GCancellable *cancellable,
                        GError **error);

### MailMsgDoneFunc ()

    void
    (*MailMsgDoneFunc) (MailMsg *msg);

### MailMsgFreeFunc ()

    void
    (*MailMsgFreeFunc) (MailMsg *msg);

### MailMsgDispatchFunc ()

    void
    (*MailMsgDispatchFunc) (gpointer msg);

### MailMsgCreateActivityFunc ()

    void
    (*MailMsgCreateActivityFunc) (GCancellable *cancellable);

### MailMsgSubmitActivityFunc ()

    void
    (*MailMsgSubmitActivityFunc) (GCancellable *cancellable);

### MailMsgFreeActivityFunc ()

    void
    (*MailMsgFreeActivityFunc) (GCancellable *cancellable);

### MailMsgCompleteActivityFunc ()

    void
    (*MailMsgCompleteActivityFunc) (GCancellable *cancellable);

### MailMsgCancelActivityFunc ()

    void
    (*MailMsgCancelActivityFunc) (GCancellable *cancellable);

### MailMsgAlertErrorFunc ()

    void
    (*MailMsgAlertErrorFunc) (GCancellable *cancellable,
                              const gchar *what,
                              const gchar *message);

### MailMsgGetAlertSinkFunc ()

    EAlertSink
    (*MailMsgGetAlertSinkFunc) (void);

### mail_msg_get_alert_sink ()

    EAlertSink *
    mail_msg_get_alert_sink (void);

### mail_msg_init ()

    void
    mail_msg_init (void);

### mail_msg_register_activities ()

    void
    mail_msg_register_activities (MailMsgCreateActivityFunc Param1,
                                  MailMsgSubmitActivityFunc Param2,
                                  MailMsgFreeActivityFunc Param3,
                                  MailMsgCompleteActivityFunc Param4,
                                  MailMsgCancelActivityFunc Param5,
                                  MailMsgAlertErrorFunc Param6,
                                  MailMsgGetAlertSinkFunc Param7);

### mail_in_main_thread ()

    gboolean
    mail_in_main_thread (void);

### mail_msg_new ()

    gpointer
    mail_msg_new (MailMsgInfo *info);

### mail_msg_new_with_cancellable ()

    gpointer
    mail_msg_new_with_cancellable (MailMsgInfo *info,
                                   GCancellable *cancellable);

### mail_msg_ref ()

    gpointer
    mail_msg_ref (gpointer msg);

### mail_msg_unref ()

    void
    mail_msg_unref (gpointer msg);

### mail_msg_check_error ()

    void
    mail_msg_check_error (gpointer msg);

### mail_msg_cancel ()

    void
    mail_msg_cancel (guint msgid);

### mail_msg_active ()

    gboolean
    mail_msg_active (void);

### mail_msg_main_loop_push ()

    void
    mail_msg_main_loop_push (gpointer msg);

### mail_msg_unordered_push ()

    void
    mail_msg_unordered_push (gpointer msg);

### mail_msg_fast_ordered_push ()

    void
    mail_msg_fast_ordered_push (gpointer msg);

### mail_msg_slow_ordered_push ()

    void
    mail_msg_slow_ordered_push (gpointer msg);

### MailMainFunc ()

    gpointer
    (*MailMainFunc) ();

### mail_call_main ()

    gpointer
    mail_call_main (mail_call_t type,
                    MailMainFunc func,
                    ...);

## Types and Values

### struct MailMsg

    struct MailMsg {
    	MailMsgInfo *info;
    	volatile gint ref_count;
    	guint seq;			/* seq number for synchronisation */
    	gint priority;			/* priority (default = 0) */
    	GCancellable *cancellable;
    	GError *error;			/* up to the caller to use this */
    };

### struct MailMsgInfo

    struct MailMsgInfo {
    	gsize size;
    	MailMsgDescFunc desc;
    	MailMsgExecFunc exec;
    	MailMsgDoneFunc done;
    	MailMsgFreeFunc free;
    };

### enum mail_call_t

#### Members

MAIL_CALL_p_p |  |
MAIL_CALL_p_pp |  |
MAIL_CALL_p_ppp |  |
MAIL_CALL_p_pppp |  |
MAIL_CALL_p_ppppp |  |
MAIL_CALL_p_ppippp |  |